/* squidclamav.h */

/*
  SquidClamav - A Clamav Antivirus Redirector for Squid
  
  This project is a modified version of the excellent Squirm Redirector
  for Squid Maintained by Chris Foote, and copyrighted
  as follow :

  Copyright (C) 1998 Chris Foote & Wayne Piekarski

  The original Squirm version used was squirm-1.0betaB. Some other parts
  are cut and paste from the ex1.c program given in the ClamAv distribution
  and are copyrighted: Copyright (C) 2002 - 2004 Tomasz Kojm

  All other code: Copyright (C) 2005-2008 Gilles Darold

  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
  Please see the file GPL in this directory for full copyright
  information.
*/


#ifndef SQUIDCLAMAV_H

#define SQUIDCLAMAV_H 1

/*************  Configuration file location  ***********/
#define CONFIG_FILE "/etc/squidclamav.conf"

/************* Proxy configuration *************/
#define MY_PROXY "http://127.0.0.1:3128"

/************* Default Clamd configuration *************/
#define CLAMD_SERVER "127.0.0.1" 
#define CLAMD_PORT "3310" 


# ifdef S_SPLINT_S
extern char *strdup (char *s) /*@*/ ;
#endif

#include<stdarg.h>
#include<sys/types.h>
#include"regex.h"
#define MAX_CHAR 256
#define LOW_CHAR 31
#define MAX_STRING 512
#define MAX_BUFF 8193
#define NORMAL_BUFF 4096
#define LOW_BUFF 1024

struct IN_BUFF {
  char *url;
  char *src_address;
  char *ident;
  char *method;
};

#define NORMAL    1
#define CONTENT   2
#define ABORT     3
#define WHITELIST 4
#define ABORTCONTENT 5

#define ACCEL_NORMAL 1
#define ACCEL_START  2
#define ACCEL_END    3

#define PATTERN_ARR_SIZE 128	/* Array of 128 patterns */

struct IP {
  short first;
  short second;
  short third;
};

struct SCPattern {
  char pattern[256];
  short type;
  int flag;
};

struct SCPattern patterns[PATTERN_ARR_SIZE];
int pattc;

void add_pattern(char *s);
regex_t *regcomp_pattern(void);
int load_in_buff(char *, struct IN_BUFF *);
int url_pattern_compare(regex_t *regexv, char *);
int content_pattern_compare(regex_t *regexv, char *);
void load_patterns(int reread);


#endif


